' 

    #INCLUDE "resdlg1.inc"

' 

FUNCTION PBmain() AS LONG

    LOCAL  Wid            as LONG
    LOCAL  Hgt            as LONG
    LOCAL  wcex           as WNDCLASSEX
    LOCAL  szClassName    as ASCIIZ * 32
    LOCAL  szDisplayName  as ASCIIZ * 128

    hInstance     = GetModuleHandle(ByVal %NULL)
    szDisplayName = "Resource Dialog Parent Window"
    szClassName   = "Resource_Win_Class"

    Sw = GetSystemMetrics(%SM_CXSCREEN)     ' get the screen X and Y size
    Sh = GetSystemMetrics(%SM_CYSCREEN)

    hIcon   = LoadIcon(hInstance,ByVal 1)   ' get system icon and cursor handles
    hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)

  ' ---------------------------------------------------------------------
  ' preload the WNDCLASSEX structure with arguments for RegisterClassEx()
  ' ---------------------------------------------------------------------

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = hCursor
    wcex.hbrBackground = %COLOR_BTNFACE + 1
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex                ' register the window class

    Wid = Sw * .75   ' Set width & height to percentage of screen size.
    Hgt = Sh * .70

    hWnd = CreateWindowEx( _
                        %WS_EX_LEFT, _           ' extended style
                        szClassName, _           ' window class name
                        szDisplayName, _         ' window title
                        %WS_OVERLAPPEDWINDOW, _  ' window style
                        Sw\2-(Wid\2), _          ' initial x position
                        Sh\2-(Hgt\2), _          ' initial y position
                        Wid, _                   ' initial x size
                        Hgt, _                   ' initial y size
                        %NULL, _                 ' parent window handle
                        %NULL, _                 ' window menu handle
                        hInstance, _             ' program instance handle
                        ByVal %NULL)             ' creation parameters

    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop              ' call the remote message loop function

END FUNCTION

' 

FUNCTION MessageLoop as DWORD

  ' ----------------------------------------------------------------
  ' the two globals used to produce the pointer to the MSG structure
  ' are to reduce the redundant load / store operations with the
  ' following 3 API functions in the DO / LOOP message loop.
  ' ----------------------------------------------------------------

    GLOBAL pmsg as DWORD                ' structure pointer
    GLOBAL MSG as tagMSG                ' MSG structure

    pmsg = VarPtr(MSG)

    do while GetMessage(ByVal pmsg,%NULL,0,0) <> 0
      TranslateMessage ByVal pmsg       ' translate any virtual-key messages
      DispatchMessage  ByVal pmsg       ' dispatch message to the nominated WndProc address
    loop

    FUNCTION = Msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as LONG, _
                 ByVal Msg    as LONG, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as LONG

    Select Case as LONG Msg             ' force integer testing of messages

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 1000
            DialogBox hInstance,ByVal 100,hWnd,CodePtr(SimpleDlgProc)
          Case 1098
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,0
          Case 1099
            DialogBox hInstance,ByVal 110,hWnd,CodePtr(AboutBoxProc)
        End Select

      Case %WM_CREATE
        ' code requird at startup here

      Case %WM_SIZE
        ' client area resizing code here

      Case %WM_CLOSE
        ' code for cleanup here

      Case %WM_DESTROY
        PostQuitMessage 0               ' terminate the message loop

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION SimpleDlgProc( _
                  ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as LONG

    Select Case as LONG Msg
      Case %WM_CLOSE            ' trap the message from the title bar button
        EndDialog hDlg,0

      Case %WM_COMMAND
        Select Case wParam
          Case %IDOK            ' trap the WM_COMMAND message from the OK button
            EndDialog hDlg,0

        End Select

    End Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION AboutBoxProc( _
                  ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as LONG

    Select Case Msg
      Case %WM_CLOSE
        EndDialog hDlg,0

      Case %WM_COMMAND
        Select Case wParam
          Case %IDCANCEL
            EndDialog hDlg,0
        End Select

    End Select

    FUNCTION = 0

END FUNCTION

' 

