' 

    #INCLUDE "resdlg2.inc"

' 

FUNCTION PBmain() AS LONG

    LOCAL  Wid            as LONG
    LOCAL  Hgt            as LONG
    LOCAL  wcex           as WNDCLASSEX
    LOCAL  szClassName    as ASCIIZ * 32
    LOCAL  szDisplayName  as ASCIIZ * 128

    hInstance     = GetModuleHandle(ByVal %NULL)
    szDisplayName = "Parent for dialog subclassed controls"
    szClassName   = "Dlg_Subclass_Class"

    Sw = GetSystemMetrics(%SM_CXSCREEN)     ' get the screen X and Y size
    Sh = GetSystemMetrics(%SM_CYSCREEN)

    hIcon   = LoadIcon(hInstance,ByVal 1)   ' get system icon and cursor handles
    hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)

  ' ---------------------------------------------------------------------
  ' preload the WNDCLASSEX structure with arguments for RegisterClassEx()
  ' ---------------------------------------------------------------------

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = hCursor
    wcex.hbrBackground = %COLOR_BTNFACE + 1
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex                ' register the window class

    Wid = Sw * .75   ' Set width & height to percentage of screen size.
    Hgt = Sh * .70

    hWnd = CreateWindowEx( _
                        %WS_EX_LEFT, _           ' extended style
                        szClassName, _           ' window class name
                        szDisplayName, _         ' window title
                        %WS_OVERLAPPEDWINDOW, _  ' window style
                        Sw\2-(Wid\2), _          ' initial x position
                        Sh\2-(Hgt\2), _          ' initial y position
                        Wid, _                   ' initial x size
                        Hgt, _                   ' initial y size
                        %NULL, _                 ' parent window handle
                        %NULL, _                 ' window menu handle
                        hInstance, _             ' program instance handle
                        ByVal %NULL)             ' creation parameters

    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop              ' call the remote message loop function

END FUNCTION

' 

FUNCTION MessageLoop as DWORD

  ' ----------------------------------------------------------------
  ' the two globals used to produce the pointer to the MSG structure
  ' are to reduce the redundant load / store operations with the
  ' following 3 API functions in the DO / LOOP message loop.
  ' ----------------------------------------------------------------

    GLOBAL pmsg as DWORD                ' structure pointer
    GLOBAL MSG as tagMSG                ' MSG structure

    pmsg = VarPtr(MSG)

    do while GetMessage(ByVal pmsg,%NULL,0,0) <> 0
      TranslateMessage ByVal pmsg       ' translate any virtual-key messages
      DispatchMessage  ByVal pmsg       ' dispatch message to the nominated WndProc address
    loop

    FUNCTION = Msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as LONG, _
                 ByVal Msg    as LONG, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as LONG

    Select Case as LONG Msg             ' force integer testing of messages

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 1000
            DialogBox hInstance,ByVal 100,hWnd,CodePtr(SubclassDlgProc)
          Case 1098
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,0
          Case 1099
            DialogBox hInstance,ByVal 110,hWnd,CodePtr(AboutBoxProc)
        End Select

      Case %WM_CREATE
        ' code requird at startup here

      Case %WM_SIZE
        ' client area resizing code here

      Case %WM_CLOSE
        ' code for cleanup here

      Case %WM_DESTROY
        PostQuitMessage 0               ' terminate the message loop

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION AboutBoxProc( _
                  ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as LONG

    Select Case as LONG Msg
      Case %WM_CLOSE
        EndDialog hDlg,0

      Case %WM_COMMAND
        Select Case wParam
          Case %IDCANCEL
            EndDialog hDlg,0
        End Select

    End Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION SubclassDlgProc( _
                  ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as LONG

    Select Case as LONG Msg
      Case %WM_CLOSE            ' trap the message from the title bar button
        EndDialog hDlg,0

      Case %WM_COMMAND
        Select Case wParam
          Case %IDOK            ' trap the WM_COMMAND message from the OK button
            EndDialog hDlg,0
        End Select

      Case %WM_INITDIALOG
        hList1 = GetDlgItem(hDlg,100)   ' get the window handles for the
        hEdit1 = GetDlgItem(hDlg,101)   ' two controls to be subclassed

      ' -----------------------------------------------------
      ' subclass the two controls by setting the %GWL_WNDPROC
      ' to the address of the subclass function.
      ' -----------------------------------------------------
        lpList1Proc = SetWindowLong(hList1,%GWL_WNDPROC, _
                                    ByVal CodePtr(List1Proc))

        lpEdit1Proc = SetWindowLong(hEdit1,%GWL_WNDPROC,_
                                    ByVal CodePtr(Edit1Proc))

      ' -------------------------------------
      ' add some string items to the list box
      ' -------------------------------------
        item1$ = "Item 1"
        item2$ = "Item 2"
        item3$ = "Item 3"
        item4$ = "Item 4"
        item5$ = "Item 5"
        item6$ = "Item 6"
        item7$ = "Item 7"
        item8$ = "Item 8"

        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item1$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item2$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item3$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item4$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item5$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item6$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item7$)
        SendMessage hList1,%LB_ADDSTRING,0,ByVal StrPtr(item8$)

    End Select

    FUNCTION = 0

END FUNCTION

' 

  ' ------------------------------
  ' the list box subclass function
  ' ------------------------------

FUNCTION List1Proc( _
              ByVal hCtl   as LONG, _
              ByVal Msg    as LONG, _
              ByVal wParam as LONG, _
              ByVal lParam as LONG) as LONG

    LOCAL csel as DWORD
    LOCAL buffer as ASCIIZ * 128

    Select Case as LONG Msg
      Case %WM_LBUTTONDBLCLK
      ' -------------------------
      ' get the current selection
      ' -------------------------
        csel = SendMessage(hCtl,%LB_GETCURSEL,0,0)

      ' ----------------------------------------
      ' copy text from selected item into buffer
      ' ----------------------------------------
        SendMessage hCtl,%LB_GETTEXT,csel,ByVal VarPtr(buffer)

        MessageBox GetParent(hCtl),ByVal VarPtr(buffer), _
                   "Greetings from the list box subclass function",%MB_OK
 
    End Select

  FUNCTION = CallWindowProc(ByVal lpList1Proc,hCtl,Msg,wParam,lParam)

END FUNCTION

' 

  ' ----------------------------------
  ' The edit control subclass function
  ' ----------------------------------

FUNCTION Edit1Proc( _
              ByVal hCtl   as LONG, _
              ByVal Msg    as LONG, _
              ByVal wParam as LONG, _
              ByVal lParam as LONG) as LONG

    LOCAL buffer as ASCIIZ * 512

  ' ---------------------------------------------------------------
  ' subclassing the edit control allows the programmer to access
  ' the internal messages that it normally processes so the results
  ' can be modified to suit the programmer's requirement.
  ' ---------------------------------------------------------------
    Select Case as LONG Msg                         ' process the messages as integers
      Case %WM_CHAR
      ' ----------------------------------
      ' allow 1234567890 "." and backspace
      ' ----------------------------------
        Select Case as LONG wParam
        ' ---------------------
        ' only allow one period
        ' ---------------------
          Case 46                                   ' test for the period "."
            GetWindowText hCtl,buffer,512
              If instr(buffer,".") <> 0 Then        ' exit if one is in the string
                FUNCTION = 0                        ' set return value to ZERO
                Exit FUNCTION                       ' exit WITHOUT calling
              End If
          ' ----------------------
          ' numbers and back space
          ' ----------------------
          Case 48 to 57,8                           ' numbers and backspace
            ' fall through to default processing
          Case Else
          ' ------------------------
          ' throw away anything else
          ' ------------------------
            FUNCTION = 0                            ' set return value to ZERO
            Exit FUNCTION                           ' exit WITHOUT calling CallWindowProc()
        End Select

    End Select

  FUNCTION = CallWindowProc(ByVal lpEdit1Proc,hCtl,Msg,wParam,lParam)

END FUNCTION

' 

